apiVersion: v1
kind: Template
labels:
  app: releasebell
  template: releasebell-buildconfig
metadata:
  annotations:
    description: ReleaseBell - BuildConfig
    iconClass: icon-nodejs
    openshift.io/display-name: ReleaseBell
    tags: releasebell
  name: releasebell-buildconfig
objects:
- apiVersion: v1
  kind: BuildConfig
  metadata:
    annotations:
      description: Builds ReleaseBell images
    labels:
      name: releasebell-${RELEASEBELL_REPOSITORY_REF}
    name: releasebell-${RELEASEBELL_REPOSITORY_REF}
  spec:
    failedBuildsHistoryLimit: 1
    resources:
      limits:
        cpu: 800m
        memory: 4Gi
    source:
      contextDir: /
      git:
        uri: ${RELEASEBELL_REPOSITORY_URL}
        ref: "${RELEASEBELL_REPOSITORY_REF}"
      type: Git
    strategy:
      type: Source
      sourceStrategy:
        env:
        - name: NODE_ENV
          value: production
        - name: NPM_MIRROR
          value: "${NPM_MIRROR}"
        forcePull: true
        from:
          kind: ImageStreamTag
          name: ${NODE_IMAGESTREAM_TAG}
    output:
      to:
        kind: ImageStreamTag
        name: releasebell:${RELEASEBELL_REPOSITORY_REF}
    postCommit:
      args:
      - -fr
      - /opt/app-root/lib/pm2/.config
      - /opt/app-root/lib/pm2/.node-gyp
      command:
      - rm
    triggers:
    - type: ImageChange
    - type: ConfigChange
parameters:
- name: RELEASEBELL_REPOSITORY_REF
  description: Set this to a branch name, tag or other ref of your repository if you are not using the default branch
  displayName: Git Reference
  value: master
- name: RELEASEBELL_REPOSITORY_URL
  description: The URL of the repository with your ReleaseBell Dockerfile
  displayName: Git Repository URL
  required: true
  value: https://gitlab.com/synacksynack/opsperator/s2i-releasebell.git
- name: NODE_IMAGESTREAM_TAG
  description: Set this to NodeJS ImageStream tag serving as base for ReleaseBell BuildConfig
  displayName: NodeJS ImageStream Tag
  required: true
  value: nodejs:master
- name: NPM_MIRROR
  description: The custom NPM mirror URL
  displayName: Custom NPM Mirror URL
  value: 'https://registry.npmjs.org'
